//+------------------------------------------------------------------+
//|                                           FPS2bouncePivotsv2.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//--- input parameters
extern bool      useSL=false;

extern double    SL_4H=0.0;
extern double    SL_Daily=0.0;
extern double    SL_Weekly=0.0;
extern double    SL_Monthly=0.0;

extern double    maxLOT=0.2;

extern double    gapH4=17.5;
extern double    gapD1=22.5;
extern double    gapW1=27.5;
extern double    gapM1=32.5;

extern int       maxOpenDays=5;
extern int       maxOpenTrades=7;

//+------------------------------------------------------------------+

bool trade2xW = false;
bool trade2xM = false;
bool tradeH4, tradeD1, tradeW1, tradeM1;

double PivotH4, PivotD1, PivotW1, PivotM1;
double pivH4, pivD1, pivW1, pivM1;
double closePriceH4, closePriceD1, closePriceW1, closePriceM1;

int ticket;
double takeProfitPips;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {
//----
  
//----
   return(0);
  }

void scalpDaily()
{	
	int hour = Hour();
   	int min  = Minute();
   	
	static datetime Time0; if (Time0 == Time[0]) return; Time0  = Time[0];
	
	double PivotD0 = (iHigh(NULL, PERIOD_D1,  0) + iLow(NULL, PERIOD_D1,  0) + iClose(NULL, PERIOD_D1,  0)) / 3;
	double closeH4 = iClose(NULL,PERIOD_H4, 1);
	
		if(closeH4 > PivotD0 && (closeH4 - PivotD0) >= 0.005)
            {   
                ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Ask + 25, "FPS2S", 131313, 0, Teal);
            }
             
        if(closeH4 < PivotD0 && (PivotD0 - closeH4) >= 0.005)
            {
                ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Ask, 3, 0, Bid + 25, "FPS2S", 131313, 0, Teal);
            } 		
}

void checkOpenOrders()
{
   int hour = Hour();
   int min  = Minute();
   int day  = Day();
   int week = DayOfWeek();   

	static datetime Time0; if (Time0 == Time[0]) return; Time0  = Time[0];
   
   string comment;
   int totalOrders=OrdersTotal();
   double priceClose = (iClose(NULL, PERIOD_D1,  1));
   
   for(int pos=0;pos<totalOrders;pos++)
    {
      if(OrderSelect(pos, MODE_TRADES, SELECT_BY_POS)==true)
      {   
         comment = StringSubstr(OrderComment(), 4, 1);           
         
			if(comment == "W" && hour== 0 && min == 0)
			{			
				if(priceClose < OrderOpenPrice() - 0.005 && OrderType() == OP_BUY)
				{	
					ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Bid, 3, 0, Ask + 25, "FPS2X", 131313, 0, Orange);
      			} else 
					if(priceClose > OrderOpenPrice()+ 0.005 && OrderType() == OP_SELL)
				{	
					ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - 25, "FPS2X", 131313, 0, Orange);
   				}
   			}
   
			if(comment == "M" && week == 1 && hour == 0)
			{			
				if(priceClose < OrderOpenPrice() - 0.0105 && OrderType() == OP_BUY)
				{	
					ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Bid, 3, 0, Ask + 50, "FPS2Z", 131313, 0, Orange);
      			} else 
					if(priceClose > OrderOpenPrice()+ 0.0105 && OrderType() == OP_SELL)
				{	
					ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - 50, "FPS2Z", 131313, 0, Orange);
   				}
			}
		}
	}
}
      
void calculatePivots()
{
   //double smma4H_Close  = iMA(NULL, PERIOD_H4, 1, 0, MODE_SMMA, PRICE_TYPICAL,1);     
   //double smmaD_Close   = iMA(NULL, PERIOD_D1, 1, 0, MODE_SMMA, PRICE_TYPICAL,1);
   //double smmaW_Close   = iMA(NULL, PERIOD_W1, 1, 0, MODE_SMMA, PRICE_TYPICAL,1); 
   //double smmaM_Close   = iMA(NULL, PERIOD_MN1,1, 0, MODE_SMMA, PRICE_TYPICAL,1);
   
   PivotH4    = (iHigh(NULL, PERIOD_H4,  1) + iLow(NULL, PERIOD_H4,  1) + iClose(NULL, PERIOD_H4,  1)) / 3;
   PivotD1    = (iHigh(NULL, PERIOD_D1,  1) + iLow(NULL, PERIOD_D1,  1) + iClose(NULL, PERIOD_D1,  1)) / 3;
   PivotW1    = (iHigh(NULL, PERIOD_W1,  1) + iLow(NULL, PERIOD_W1,  1) + iClose(NULL, PERIOD_W1,  1)) / 3;
   PivotM1    = (iHigh(NULL, PERIOD_MN1, 1) + iLow(NULL, PERIOD_MN1, 1) + iClose(NULL, PERIOD_MN1, 1)) / 3;
   
   closePriceH4 = iClose(NULL,PERIOD_H4,  1);
   closePriceD1 = iClose(NULL,PERIOD_D1,  1);
   closePriceW1 = iClose(NULL,PERIOD_W1,  1);
   closePriceM1 = iClose(NULL,PERIOD_MN1, 1);
   
   pivH4 = MathAbs(closePriceH4 - PivotH4);
   pivD1 = MathAbs(closePriceD1 - PivotD1);
   pivW1 = MathAbs(closePriceW1 - PivotW1);
   pivM1 = MathAbs(closePriceM1 - PivotM1);
   
   tradeH4 = false;
   tradeD1 = false;
   tradeW1 = false;
   tradeM1 = false;
   
   if(pivH4 >= gapH4/10000) tradeH4 = true;
   if(pivD1 >= gapD1/10000) tradeD1 = true;
   if(pivW1 >= gapW1/10000) tradeW1 = true;
   if(pivM1 >= gapM1/10000) tradeM1 = true;   
}

void moveBE()
{

int totalOrders=OrdersTotal(); 
   if (totalOrders >= maxOpenTrades)return(0);  
    Print("Order Total >>>>>>>>>>>>>>>>>>>>>>>>  ", OrdersTotal());    
    
    string comment;
    
    for(int pos=0;pos<totalOrders;pos++)
    {
      if(OrderSelect(pos, MODE_TRADES, SELECT_BY_POS)==true)
      {   
         comment=OrderComment();
         Print("Order Opened in >>>>  ", comment);             
         string subcomment=StringSubstr(comment, 4, 1);
         Print("Order last Comment >>>>>>>>>>>>>>>>  ", subcomment);

         if(subcomment == "H")
         {
            if(OrderType() == OP_BUY)
            {
               if(Ask-OrderOpenPrice() > 0.00045)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice()+Point*10, OrderTakeProfit(), 0, White);
               }
            }else
            	if(OrderType() == OP_SELL)
            	{
               		if(OrderOpenPrice()-Bid > 0.00045)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice()-Point*10, OrderTakeProfit(), 0, White);
               }
            } 
         }
         
         if(subcomment == "D")
         {
            if(OrderType() == OP_BUY)
            {
               if(Ask-OrderOpenPrice() > 0.00095)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice()+Point*20, OrderTakeProfit(), 0, White);
               }
            }
            
            if(OrderType() == OP_SELL)
            {
               if(OrderOpenPrice()-Bid > 0.00075)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice()-Point*20, OrderTakeProfit(), 0, White);
               }
            } 
         }
      }
   }
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  Comment(" ",
  "\n",
  "ForexProService",
  "\n",
  "_________________________",
  "\n",
  "Balance     = ",AccountBalance(),
  "\n",
  "Equity      = ",AccountEquity(),
  "\n",
  "Margin      = ",AccountMargin(),
  "\n",
  "Free mrg   = ",AccountFreeMargin(),
  "\n",
  "Current Server time is : ", TimeToStr(TimeCurrent()),
  "\n",
  "Minutos : ", Minute(),
   "\n",
  "Hora    : ", Hour(), 
   "\n",
  "Dia     : ", Day(),
   "\n",
  "Dia Semana : ", DayOfWeek());

   int hour = Hour();
   int min  = Minute();
   int day  = Day();
   int week = DayOfWeek();
   
   moveBE(); 
    
   static datetime Time0; if (Time0 == Time[0]) return; Time0  = Time[0];         
	
	scalpDaily();
	calculatePivots();
	
      if(min == 0){
        
         if(hour == 0 || hour == 4 || hour == 8 || hour == 12 || hour == 16 || hour == 20){
            
            takeProfitPips = MathAbs(closePriceH4 - PivotH4)*0.3;
            
            if(closePriceH4 > PivotH4 && tradeH4 == true)
            {   
                ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - takeProfitPips, "FPS2H", 131313, 0, Red);
            } 
         
            if(closePriceH4 < PivotH4 && tradeH4 == true)
            {
                ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Ask, 3, 0, Ask + takeProfitPips, "FPS2H", 131313, 0, Red);
            } 
         }
     
         if(hour == 0){         
            
            takeProfitPips = MathAbs(closePriceD1 - PivotD1)*0.45;
            
            if(closePriceD1 > PivotD1 && tradeD1 == true)
            {
                ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - takeProfitPips, "FPS2D", 131313, 0, Blue);
            } 

            if(closePriceD1 < PivotD1 && tradeD1 == true)
            {
                ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Ask, 3, 0, Ask + takeProfitPips, "FPS2D", 131313, 0, Blue);
            }

            checkOpenOrders();
         }       
      }     

      if (week == 1 && hour == 0){ 

         takeProfitPips = MathAbs(closePriceW1 - PivotW1)*0.70;
            
         if(closePriceW1 > PivotW1 && tradeW1 == true)
            {
                ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - takeProfitPips, "FPS2W", 131313, 0, Blue);
            } 

            if(closePriceW1 < PivotW1 && tradeW1 == true)
            {
                ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Ask, 3, 0, Ask + takeProfitPips, "FPS2W", 131313, 0, Blue);
            }
            
            checkOpenOrders();
      }
   
      if(day == 1 && hour == 0){

         takeProfitPips = MathAbs(closePriceM1 - PivotM1)*0.85;
            
         if(closePriceM1 > PivotM1 && tradeM1 == true)
         {
            ticket=OrderSend(Symbol(), OP_SELL, maxLOT, Bid, 3, 0, Bid - takeProfitPips, "FPS2M", 131313, 0, Blue);
         } 

         if(closePriceM1 < PivotM1 && tradeM1 == true)
         {
            ticket=OrderSend(Symbol(), OP_BUY, maxLOT, Ask, 3, 0, Ask + takeProfitPips, "FPS2M", 131313, 0, Blue);
         }               
      }   
//----
   return(0);       
}
//+------------------------------------------------------------------+